Bug 198414

Summary: [WHLSL] Implement arrays and MakeArrayReference
Product: WebKit Reporter: Saam Barati <sbarati>
Component: WebGPUAssignee: Saam Barati <sbarati>
Status: RESOLVED FIXED    
Severity: Normal CC: commit-queue, fpizlo, jonlee, justin_fan, mmaxfield, rmorisset, tsavell, webkit-bug-importer
Priority: P2 Keywords: InRadar
Version: WebKit Nightly Build   
Hardware: Unspecified   
OS: Unspecified   
See Also: https://bugs.webkit.org/show_bug.cgi?id=198163
Bug Depends on:    
Bug Blocks: 195681, 199197    
Attachments:
Description Flags
WIP
none
patch
mmaxfield: review+
patch for landing none

Description Saam Barati 2019-05-31 02:28:59 PDT
```int[1000] x;``` fails to compile.
Comment 1 Saam Barati 2019-06-20 18:31:22 PDT
Doing this now.
Comment 2 Saam Barati 2019-06-21 18:56:52 PDT
Created attachment 372664 [details]
WIP

I think it might almost be done. Encountering some checker bugs when I have a function with the same array type in two different variables, which I need to fix.

I think I also need to make this a compile error:
```
int[42] x;
&x
```
Comment 3 Saam Barati 2019-06-25 13:48:13 PDT
Created attachment 372859 [details]
patch
Comment 4 Myles C. Maxfield 2019-06-26 17:21:15 PDT
Comment on attachment 372859 [details]
patch

View in context: https://bugs.webkit.org/attachment.cgi?id=372859&action=review

> Source/WebCore/Modules/webgpu/WHLSL/Metal/WHLSLFunctionWriter.cpp:635
> +        m_stringBuilder.append(makeString(mangledTypeName, ' ', variableName, " = { ", takeLastValue(), ", 1 };\n"));

I know you didn’t change this, but shouldn’t this be 0 if the original pointer is null?

> Source/WebCore/Modules/webgpu/WHLSL/Metal/WHLSLNativeFunctionWriter.cpp:-178
> -            stringBuilder.append(makeString("    return ", arrayParameterType.numElements(), "u;\n"));

The “u” suffix was to make it an unsigned, in case it’s > 2B

> Source/WebCore/Modules/webgpu/WHLSL/Metal/WHLSLTypeNamer.cpp:343
> +    return &*iterator;

Isn’t returning a pointer pointing into the array a use after free if something else gets added to the array before you dereference the pointer? I think that’s why I made it an index instead of a pointer.

> LayoutTests/webgpu/whlsl-huge-array.html:97
> +    shouldBe("resultsInt32Array[0]", "1");

Can we update these tests to use the pattern that caides tests to pass if the machine doesn’t support Meta? I’ve migrated all the existing tests.
Comment 5 Saam Barati 2019-06-26 17:24:24 PDT
Comment on attachment 372859 [details]
patch

View in context: https://bugs.webkit.org/attachment.cgi?id=372859&action=review

>> Source/WebCore/Modules/webgpu/WHLSL/Metal/WHLSLFunctionWriter.cpp:635
>> +        m_stringBuilder.append(makeString(mangledTypeName, ' ', variableName, " = { ", takeLastValue(), ", 1 };\n"));
> 
> I know you didn’t change this, but shouldn’t this be 0 if the original pointer is null?

Nice catch. I'll add a test.

>> Source/WebCore/Modules/webgpu/WHLSL/Metal/WHLSLNativeFunctionWriter.cpp:-178
>> -            stringBuilder.append(makeString("    return ", arrayParameterType.numElements(), "u;\n"));
> 
> The “u” suffix was to make it an unsigned, in case it’s > 2B

That shouldn't matter.

e.g, uint(-1) == UINT_MAX.

Casting from int to uint is a nop

>> Source/WebCore/Modules/webgpu/WHLSL/Metal/WHLSLTypeNamer.cpp:343
>> +    return &*iterator;
> 
> Isn’t returning a pointer pointing into the array a use after free if something else gets added to the array before you dereference the pointer? I think that’s why I made it an index instead of a pointer.

We're not returning a pointer into the vector. We're calling "operator&" on a UniqueRef

>> LayoutTests/webgpu/whlsl-huge-array.html:97
>> +    shouldBe("resultsInt32Array[0]", "1");
> 
> Can we update these tests to use the pattern that caides tests to pass if the machine doesn’t support Meta? I’ve migrated all the existing tests.

Will do.
Comment 6 Saam Barati 2019-06-27 00:35:12 PDT
Created attachment 373006 [details]
patch for landing
Comment 7 WebKit Commit Bot 2019-06-27 01:20:01 PDT
Comment on attachment 373006 [details]
patch for landing

Clearing flags on attachment: 373006

Committed r246875: <https://trac.webkit.org/changeset/246875>
Comment 8 WebKit Commit Bot 2019-06-27 01:20:03 PDT
All reviewed patches have been landed.  Closing bug.
Comment 9 Radar WebKit Bug Importer 2019-06-27 01:23:43 PDT
<rdar://problem/52242516>
Comment 10 Truitt Savell 2019-06-27 09:12:03 PDT
It looks like the changes in https://trac.webkit.org/changeset/246875/webkit
Broke two tests:
webgpu/whlsl-huge-array.html
webgpu/whlsl-make-array-reference.html

History:
http://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.html#showAllRuns=true&tests=webgpu%2Fwhlsl-huge-array.html%20webgpu%2Fwhlsl-make-array-reference.html

Diff:
--- /Volumes/Data/slave/highsierra-debug-tests-wk2/build/layout-test-results/webgpu/whlsl-huge-array-expected.txt
+++ /Volumes/Data/slave/highsierra-debug-tests-wk2/build/layout-test-results/webgpu/whlsl-huge-array-actual.txt
@@ -1,4 +1,4 @@
-PASS 
+FAIL 
 PASS successfullyParsed is true
 
 TEST COMPLETE
Comment 11 Saam Barati 2019-06-27 10:03:42 PDT
(In reply to Truitt Savell from comment #10)
> It looks like the changes in https://trac.webkit.org/changeset/246875/webkit
> Broke two tests:
> webgpu/whlsl-huge-array.html
> webgpu/whlsl-make-array-reference.html
> 
> History:
> http://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> html#showAllRuns=true&tests=webgpu%2Fwhlsl-huge-array.html%20webgpu%2Fwhlsl-
> make-array-reference.html
> 
> Diff:
> ---
> /Volumes/Data/slave/highsierra-debug-tests-wk2/build/layout-test-results/
> webgpu/whlsl-huge-array-expected.txt
> +++
> /Volumes/Data/slave/highsierra-debug-tests-wk2/build/layout-test-results/
> webgpu/whlsl-huge-array-actual.txt
> @@ -1,4 +1,4 @@
> -PASS 
> +FAIL 
>  PASS successfullyParsed is true
>  
>  TEST COMPLETE

We're crashing LLVM in selection DAG:

Process:               MTLCompilerService [65343]
Path:                  /System/Library/Frameworks/Metal.framework/Versions/A/XPCServices/MTLCompilerService.xpc/Contents/MacOS/MTLCompilerService
Identifier:            MTLCompilerService
Version:               125.30 (125.30)
Code Type:             X86-64 (Native)
Parent Process:        ??? [1]
Responsible:           com.apple.WebKit.WebContent.Development [65337]
User ID:               501

Date/Time:             2019-06-27 09:33:20.165 -0700
OS Version:            Mac OS X 10.13.6 (17G7024)
Report Version:        12
Anonymous UUID:        618B3AF5-9517-D230-2179-6355C81F3E3C


Time Awake Since Boot: 3600000 seconds

System Integrity Protection: enabled

Crashed Thread:        4

Exception Type:        EXC_BAD_ACCESS (SIGSEGV)
Exception Codes:       KERN_INVALID_ADDRESS at 0x0000000000000028
Exception Note:        EXC_CORPSE_NOTIFY

Termination Signal:    Segmentation fault: 11
Termination Reason:    Namespace SIGNAL, Code 0xb
Terminating Process:   exc handler [0]

VM Regions Near 0x28:
--> 
    __TEXT                 00000001028de000-00000001028e0000 [    8K] r-x/rwx SM=COW  /System/Library/Frameworks/Metal.framework/Versions/A/XPCServices/MTLCompilerService.xpc/Contents/MacOS/MTLCompilerService

Thread 0:
0   libsystem_kernel.dylib        	0x00007fff7496cd9a __semwait_signal_nocancel + 10
1   libsystem_c.dylib             	0x00007fff74871e77 nanosleep$NOCANCEL + 188
2   libsystem_c.dylib             	0x00007fff74898830 sleep$NOCANCEL + 41
3   libdispatch.dylib             	0x00007fff747eec58 _dispatch_queue_cleanup2 + 107
4   libsystem_pthread.dylib       	0x00007fff74b361aa _pthread_tsd_cleanup + 534
5   libsystem_pthread.dylib       	0x00007fff74b35ee9 _pthread_exit + 79
6   libsystem_pthread.dylib       	0x00007fff74b36945 pthread_exit + 30
7   libdispatch.dylib             	0x00007fff747eebc5 dispatch_main + 110
8   libxpc.dylib                  	0x00007fff74b76d1a _xpc_objc_main + 487
9   libxpc.dylib                  	0x00007fff74b759ca xpc_main + 433
10  com.apple.MTLCompilerService  	0x00000001028df135 main + 130
11  libdyld.dylib                 	0x00007fff7481c015 start + 1

Thread 1:: Dispatch queue: com.apple.root.default-qos.overcommit
0   libsystem_kernel.dylib        	0x00007fff7496d022 __sigsuspend_nocancel + 10
1   libdispatch.dylib             	0x00007fff747eecd5 _dispatch_sigsuspend + 21
2   libdispatch.dylib             	0x00007fff747eecc0 _dispatch_sig_thread + 53

Thread 2:
0   libsystem_kernel.dylib        	0x00007fff7496d28a __workq_kernreturn + 10
1   libsystem_pthread.dylib       	0x00007fff74b3420e _pthread_wqthread + 1552
2   libsystem_pthread.dylib       	0x00007fff74b33be9 start_wqthread + 13

Thread 3:
0   libsystem_kernel.dylib        	0x00007fff7496d28a __workq_kernreturn + 10
1   libsystem_pthread.dylib       	0x00007fff74b34009 _pthread_wqthread + 1035
2   libsystem_pthread.dylib       	0x00007fff74b33be9 start_wqthread + 13

Thread 4 Crashed:
0   libLLVM.dylib                 	0x00007fff635e72fe llvm::SelectionDAG::getAtomic(unsigned int, llvm::SDLoc const&, llvm::EVT, llvm::SDValue, llvm::SDValue, llvm::SDValue, llvm::MachineMemOperand*, llvm::AtomicOrdering, llvm::SynchronizationScope) + 90
1   libLLVM.dylib                 	0x00007fff6355bb83 0x7fff62f70000 + 6208387
2   libLLVM.dylib                 	0x00007fff63556292 0x7fff62f70000 + 6185618
3   libLLVM.dylib                 	0x00007fff6356dda9 0x7fff62f70000 + 6282665
4   libLLVM.dylib                 	0x00007fff63570fdd llvm::SelectionDAG::LegalizeTypes() + 57
5   libLLVM.dylib                 	0x00007fff635f9517 llvm::SelectionDAGISel::CodeGenAndEmitDAG() + 343
6   libLLVM.dylib                 	0x00007fff635f8a40 llvm::SelectionDAGISel::SelectAllBasicBlocks(llvm::Function const&) + 2848
7   libLLVM.dylib                 	0x00007fff635f7792 llvm::SelectionDAGISel::runOnMachineFunction(llvm::MachineFunction&) + 1186
8   libLLVM.dylib                 	0x00007fff6314496b llvm::MachineFunctionPass::runOnFunction(llvm::Function&) + 99
9   libLLVM.dylib                 	0x00007fff632969d1 llvm::FPPassManager::runOnFunction(llvm::Function&) + 279
10  libLLVM.dylib                 	0x00007fff63296b7b llvm::FPPassManager::runOnModule(llvm::Module&) + 49
11  libLLVM.dylib                 	0x00007fff63296ea5 llvm::legacy::PassManagerImpl::run(llvm::Module&) + 577
12  libMTLIntelCompilerPlugin.dylib	0x0000000102a92668 MTLIntelCompiler::generateIGIL(llvm::Module*, MTLIntelFunctionType, std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> >&, std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> >&, bool, std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> >&) + 710
13  libMTLIntelCompilerPlugin.dylib	0x0000000102a863eb MTLCompilerBuildRequest + 288
14  com.apple.MTLCompiler         	0x00007fff67617387 MTLCompilerObject::buildRequest(unsigned int, unsigned int, void const*, unsigned long, void (unsigned int, void const*, unsigned long, char const*) block_pointer) + 10535
15  com.apple.MTLCompilerService  	0x00000001028df0aa compileRequestMain + 52
16  com.apple.MTLCompilerService  	0x00000001028df473 invocation function for block in MTLCompilerServiceHandleEvent(NSObject<OS_xpc_object>*) + 746
17  libxpc.dylib                  	0x00007fff74b71773 _xpc_connection_call_event_handler + 35
18  libxpc.dylib                  	0x00007fff74b6ff31 _xpc_connection_mach_event + 1092
19  libdispatch.dylib             	0x00007fff747e7da9 _dispatch_client_callout4 + 9
20  libdispatch.dylib             	0x00007fff747e8062 _dispatch_mach_msg_invoke + 488
21  libdispatch.dylib             	0x00007fff747f707a _dispatch_queue_serial_drain + 222
22  libdispatch.dylib             	0x00007fff747e6972 _dispatch_mach_invoke + 534
23  libdispatch.dylib             	0x00007fff747f707a _dispatch_queue_serial_drain + 222
24  libdispatch.dylib             	0x00007fff747ea166 _dispatch_queue_invoke + 373
25  libdispatch.dylib             	0x00007fff747f7f0d _dispatch_root_queue_drain_deferred_wlh + 332
26  libdispatch.dylib             	0x00007fff747fbd21 _dispatch_workloop_worker_thread + 880
27  libsystem_pthread.dylib       	0x00007fff74b33fd2 _pthread_wqthread + 980
28  libsystem_pthread.dylib       	0x00007fff74b33be9 start_wqthread + 13

Thread 5:
0   libsystem_kernel.dylib        	0x00007fff7496d28a __workq_kernreturn + 10
1   libsystem_pthread.dylib       	0x00007fff74b34009 _pthread_wqthread + 1035
2   libsystem_pthread.dylib       	0x00007fff74b33be9 start_wqthread + 13

Thread 4 crashed with X86 Thread State (64-bit):
  rax: 0x0000000000000000  rbx: 0x0000000000000029  rcx: 0x0000000000000000  rdx: 0x00007000092d73f0
  rdi: 0x00007fd74a608310  rsi: 0x0000000000000029  rbp: 0x00007000092d73a0  rsp: 0x00007000092d72d0
   r8: 0x0000000000000000   r9: 0x0000000000000000  r10: 0x0000000000000001  r11: 0x0000000000000007
  r12: 0x00007000092d73b0  r13: 0x0000000000000000  r14: 0x00007fd74a608310  r15: 0x00007000092d73c0
  rip: 0x00007fff635e72fe  rfl: 0x0000000000010287  cr2: 0x0000000000000028
  
Logical CPU:     4
Error Code:      0x00000004
Trap Number:     14


Binary Images:
       0x1028de000 -        0x1028dfff7  com.apple.MTLCompilerService (125.30 - 125.30) <3C03D3C7-92FD-3ED7-A734-57AD085B67D4> /System/Library/Frameworks/Metal.framework/Versions/A/XPCServices/MTLCompilerService.xpc/Contents/MacOS/MTLCompilerService
       0x102a85000 -        0x102aa4fff  libMTLIntelCompilerPlugin.dylib (10.36.25.1) <C8C90E58-E021-3BB9-A70F-18E61154A15A> /System/Library/Extensions/AppleIntelHD4000GraphicsMTLDriver.bundle/Contents/MacOS/libMTLIntelCompilerPlugin.dylib
       0x102ae5000 -        0x102f83ff7  iCBE.dylib (10.36.25.1) <033C01D3-CC67-3854-891A-0BE3EC7F18D8> /System/Library/Extensions/AppleIntelHD4000GraphicsGLDriver.bundle/Contents/MacOS/iCBE.dylib
       0x104e4d000 -        0x104e97acf  dyld (551.5) <30B355CB-35BA-3112-AA76-4E46CD45F699> /usr/lib/dyld
    0x7fff46285000 -     0x7fff463e3ff7  libIGIL-Metal.dylib (10.36.25.1) <01ADDA7F-18F1-3185-9E9C-AACC641884C9> /System/Library/Extensions/AppleIntelGraphicsShared.bundle/Contents/MacOS/libIGIL-Metal.dylib
    0x7fff48ace000 -     0x7fff48acefff  com.apple.Accelerate (1.11 - Accelerate 1.11) <2EF00EFE-06E8-3082-85C3-2988B422A19D> /System/Library/Frameworks/Accelerate.framework/Versions/A/Accelerate
    0x7fff48ae7000 -     0x7fff49235ffb  com.apple.vImage (8.1 - ???) <56C275C1-459F-37CD-BF29-2E6D81C29E53> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vImage.framework/Versions/A/vImage
    0x7fff49236000 -     0x7fff493d6ff3  libBLAS.dylib (1211.50.2) <93259222-2D94-333D-A1EB-09C6FC4A64B4> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libBLAS.dylib
    0x7fff493d7000 -     0x7fff49411fef  libBNNS.dylib (38.1) <0AAE0109-71D5-3B26-8401-3E62DDF97624> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libBNNS.dylib
    0x7fff49412000 -     0x7fff497ebff7  libLAPACK.dylib (1211.50.2) <70781D0B-AEAD-33EB-9900-10DC30F37D61> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libLAPACK.dylib
    0x7fff497ec000 -     0x7fff49802ff7  libLinearAlgebra.dylib (1211.50.2) <FB5A35EA-D636-3D69-AB53-B67E1EB8134C> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libLinearAlgebra.dylib
    0x7fff49803000 -     0x7fff49808ff3  libQuadrature.dylib (3) <3D6BF66A-55B2-3692-BAC7-DEB0C676ED29> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libQuadrature.dylib
    0x7fff49809000 -     0x7fff49889fff  libSparse.dylib (79.50.2) <0DC25CDD-F8C1-3D6E-B472-8B060708424F> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libSparse.dylib
    0x7fff4988a000 -     0x7fff4989cff7  libSparseBLAS.dylib (1211.50.2) <994A7D7E-FA3B-3943-A59C-8150B9AF86BE> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libSparseBLAS.dylib
    0x7fff4989d000 -     0x7fff49a10fe7  libvDSP.dylib (622.50.5) <4BF310F4-31A3-3DA5-80E4-7F8014AD380B> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libvDSP.dylib
    0x7fff49a11000 -     0x7fff49ac7fef  libvMisc.dylib (622.50.5) <88143A88-4FDE-35A1-85FE-54FF0C2A9E43> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/libvMisc.dylib
    0x7fff49ac8000 -     0x7fff49ac8fff  com.apple.Accelerate.vecLib (3.11 - vecLib 3.11) <880DEF40-389A-3F56-ACA1-B62A5BC57E59> /System/Library/Frameworks/Accelerate.framework/Versions/A/Frameworks/vecLib.framework/Versions/A/vecLib
    0x7fff4ac6c000 -     0x7fff4ac6cfff  com.apple.ApplicationServices (48 - 50) <63B0C61F-CFE8-3884-853F-E6FB6CD84A44> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/ApplicationServices
    0x7fff4ac6d000 -     0x7fff4acd3fff  com.apple.ApplicationServices.ATS (377 - 445.5) <703CE7E4-426A-35C0-A229-F140F30F5340> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/ATS
    0x7fff4ad6c000 -     0x7fff4ae8efff  libFontParser.dylib (222.1.7) <9C4CEFB4-0F08-3B60-BD50-0120A37F6EA2> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/Resources/libFontParser.dylib
    0x7fff4ae8f000 -     0x7fff4aed9ff7  libFontRegistry.dylib (221.5) <8F68EA59-C8EE-3FA3-BD19-0F1A58441440> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ATS.framework/Versions/A/Resources/libFontRegistry.dylib
    0x7fff4b01b000 -     0x7fff4b01fff3  com.apple.ColorSyncLegacy (4.13.0 - 1) <A5FB2694-1559-34A8-A3D3-2029F68A63CA> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/ColorSyncLegacy.framework/Versions/A/ColorSyncLegacy
    0x7fff4b0bf000 -     0x7fff4b111ffb  com.apple.HIServices (1.22 - 625) <78A1FB4F-A39C-3159-B285-600C997335FB> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/HIServices.framework/Versions/A/HIServices
    0x7fff4b112000 -     0x7fff4b120fff  com.apple.LangAnalysis (1.7.0 - 1.7.0) <B65FF7E6-E9B5-34D8-8CA7-63D415A8A9A6> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/LangAnalysis.framework/Versions/A/LangAnalysis
    0x7fff4b121000 -     0x7fff4b16dfff  com.apple.print.framework.PrintCore (13.4 - 503.2) <B90C67C1-0292-3CEC-885D-F1882CD104BE> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/PrintCore.framework/Versions/A/PrintCore
    0x7fff4b16e000 -     0x7fff4b1a8fff  com.apple.QD (3.12 - 404.2) <38B20AFF-9D54-3B52-A6DC-C0D71380AA5F> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/QD.framework/Versions/A/QD
    0x7fff4b1a9000 -     0x7fff4b1b5fff  com.apple.speech.synthesis.framework (7.8.1 - 7.8.1) <A08DE016-C8F2-3B0E-BD34-15959D13DBF0> /System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/SpeechSynthesis.framework/Versions/A/SpeechSynthesis
    0x7fff4b1b6000 -     0x7fff4b444ff7  com.apple.audio.toolbox.AudioToolbox (1.14 - 1.14) <287960E1-605E-3789-9237-FDC3F3EC4000> /System/Library/Frameworks/AudioToolbox.framework/Versions/A/AudioToolbox
    0x7fff4b769000 -     0x7fff4bb04ff7  com.apple.CFNetwork (902.3.1 - 902.3.1) <4C012538-BB8A-32F3-AACA-011092BEFAB1> /System/Library/Frameworks/CFNetwork.framework/Versions/A/CFNetwork
    0x7fff4c039000 -     0x7fff4c0f2fff  com.apple.ColorSync (4.13.0 - 3325) <D283C285-447D-3258-A7E4-59532123B8FF> /System/Library/Frameworks/ColorSync.framework/Versions/A/ColorSync
    0x7fff4c27f000 -     0x7fff4c312ff7  com.apple.audio.CoreAudio (4.3.0 - 4.3.0) <A862985C-536F-3E01-83CA-E510B2204DA6> /System/Library/Frameworks/CoreAudio.framework/Versions/A/CoreAudio
    0x7fff4c3a3000 -     0x7fff4c707ff3  com.apple.CoreData (120 - 851) <8D605466-8676-3D45-9A4B-8980971551C3> /System/Library/Frameworks/CoreData.framework/Versions/A/CoreData
    0x7fff4c708000 -     0x7fff4c7ebfff  com.apple.CoreDisplay (99.14 - 99.14) <A1B91ADD-828D-33A0-8A92-CC3F83DF89D0> /System/Library/Frameworks/CoreDisplay.framework/Versions/A/CoreDisplay
    0x7fff4c7ec000 -     0x7fff4cc86fff  com.apple.CoreFoundation (6.9 - 1454.96) <B4B4E782-6FF9-39DF-9B6A-FCB4B04FA47F> /System/Library/Frameworks/CoreFoundation.framework/Versions/A/CoreFoundation
    0x7fff4cc88000 -     0x7fff4d2b6ff7  com.apple.CoreGraphics (2.0 - 1161.21.2) <9027DB33-59F0-3CD2-8DBF-67B249894A2F> /System/Library/Frameworks/CoreGraphics.framework/Versions/A/CoreGraphics
    0x7fff4d2b8000 -     0x7fff4d5a7fff  com.apple.CoreImage (13.0.0 - 579.5) <E40914F8-1937-3D52-903D-2916003CA6E8> /System/Library/Frameworks/CoreImage.framework/Versions/A/CoreImage
    0x7fff4d97c000 -     0x7fff4d97cfff  com.apple.CoreServices (822.37 - 822.37) <58ADA4D7-2FC0-32AC-BB75-DD8834454ACC> /System/Library/Frameworks/CoreServices.framework/Versions/A/CoreServices
    0x7fff4d97d000 -     0x7fff4d9f1ffb  com.apple.AE (735.2 - 735.2) <690A6F47-1306-371F-B257-783D8F83EA9E> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/AE.framework/Versions/A/AE
    0x7fff4d9f2000 -     0x7fff4dcc9fff  com.apple.CoreServices.CarbonCore (1178.4.1 - 1178.4.1) <009E1ABC-A66B-3355-9E6C-0D4E9B7BEA4C> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/CarbonCore.framework/Versions/A/CarbonCore
    0x7fff4dcca000 -     0x7fff4dcfefff  com.apple.DictionaryServices (1.2 - 284.2) <6505B075-41C3-3C62-A4C3-85CE3F6825CD> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/DictionaryServices.framework/Versions/A/DictionaryServices
    0x7fff4dcff000 -     0x7fff4dd07ffb  com.apple.CoreServices.FSEvents (1239.50.1 - 1239.50.1) <3637CEC7-DF0E-320E-9634-44A442925C65> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/FSEvents.framework/Versions/A/FSEvents
    0x7fff4dd08000 -     0x7fff4dec6ff7  com.apple.LaunchServices (822.37 - 822.37) <5FD5F15D-0D10-302E-AF17-AD2A3B9B5926> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/LaunchServices
    0x7fff4dec7000 -     0x7fff4df77fff  com.apple.Metadata (10.7.0 - 1191.7) <3DD530A7-E104-3469-98BB-20449834B2FE> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/Metadata.framework/Versions/A/Metadata
    0x7fff4df78000 -     0x7fff4dfd8fff  com.apple.CoreServices.OSServices (822.37 - 822.37) <789FD38A-B612-3A66-8EE8-27A344FAD7A7> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/OSServices.framework/Versions/A/OSServices
    0x7fff4dfd9000 -     0x7fff4e047fff  com.apple.SearchKit (1.4.0 - 1.4.0) <3662545A-B1CF-3079-BDCD-C83855CEFEEE> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/SearchKit.framework/Versions/A/SearchKit
    0x7fff4e048000 -     0x7fff4e06cffb  com.apple.coreservices.SharedFileList (71.21 - 71.21) <1B5228EF-D869-3A50-A373-7F4B0289FADD> /System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/SharedFileList.framework/Versions/A/SharedFileList
    0x7fff4e30d000 -     0x7fff4e45dfff  com.apple.CoreText (352.0 - 578.22) <6129F39D-284D-3BBF-8999-7854AB61C01C> /System/Library/Frameworks/CoreText.framework/Versions/A/CoreText
    0x7fff4e45e000 -     0x7fff4e498fff  com.apple.CoreVideo (1.8 - 0.0) <86CCC036-51BB-3DD1-9601-D93798BCCD0F> /System/Library/Frameworks/CoreVideo.framework/Versions/A/CoreVideo
    0x7fff4e79f000 -     0x7fff4e7a4fff  com.apple.DiskArbitration (2.7 - 2.7) <2F628584-8177-3894-92CE-9CA6089B61C6> /System/Library/Frameworks/DiskArbitration.framework/Versions/A/DiskArbitration
    0x7fff4e965000 -     0x7fff4ed2bff3  com.apple.Foundation (6.9 - 1454.96) <0DD43942-B183-3A39-BCDE-E3CCA0E4DE59> /System/Library/Frameworks/Foundation.framework/Versions/C/Foundation
    0x7fff4ed9c000 -     0x7fff4edccff3  com.apple.GSS (4.0 - 2.0) <62F1A2A7-EBDB-3CAB-8306-4DA9EFA70E81> /System/Library/Frameworks/GSS.framework/Versions/A/GSS
    0x7fff4f042000 -     0x7fff4f0ddfff  com.apple.framework.IOKit (2.0.2 - 1445.71.6) <9337E730-48FF-306C-B8A2-5DFCDBECD9F6> /System/Library/Frameworks/IOKit.framework/Versions/A/IOKit
    0x7fff4f0df000 -     0x7fff4f0e6fff  com.apple.IOSurface (211.16 - 211.16) <3A727DBA-324D-3ED5-9665-573D091A9B67> /System/Library/Frameworks/IOSurface.framework/Versions/A/IOSurface
    0x7fff4f13d000 -     0x7fff4f2bafff  com.apple.ImageIO.framework (3.3.0 - 1739.3.1) <3564ADD2-803F-35CC-AB7F-6F41241010FF> /System/Library/Frameworks/ImageIO.framework/Versions/A/ImageIO
    0x7fff4f2bb000 -     0x7fff4f2bfffb  libGIF.dylib (1739.3.1) <3CB9E6D5-FF76-37E5-921D-57F2C36D8CFC> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libGIF.dylib
    0x7fff4f2c0000 -     0x7fff4f3a7ff7  libJP2.dylib (1739.3.1) <2B233EA0-59CC-3D7D-81AF-F471448F5271> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libJP2.dylib
    0x7fff4f3a8000 -     0x7fff4f3cbfff  libJPEG.dylib (1739.3.1) <4B3C1085-9177-3872-BCAF-965CBCD6A906> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libJPEG.dylib
    0x7fff4f6a8000 -     0x7fff4f6ceff3  libPng.dylib (1739.3.1) <734D972E-0BD6-3DAC-A465-43A8AF9E0BC8> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libPng.dylib
    0x7fff4f6cf000 -     0x7fff4f6d1ff3  libRadiance.dylib (1739.3.1) <99967613-358F-377D-BEC2-C52CC2B18811> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libRadiance.dylib
    0x7fff4f6d2000 -     0x7fff4f71fff3  libTIFF.dylib (1739.3.1) <BEAC3497-7D7F-3A09-B232-07E9792ACF88> /System/Library/Frameworks/ImageIO.framework/Versions/A/Resources/libTIFF.dylib
    0x7fff505d9000 -     0x7fff505f2ff7  com.apple.Kerberos (3.0 - 1) <F86DCCDF-93C1-38B3-82C2-477C12E8EE6D> /System/Library/Frameworks/Kerberos.framework/Versions/A/Kerberos
    0x7fff50fd4000 -     0x7fff51055fff  com.apple.Metal (125.30 - 125.30) <659DF560-9B89-3E8A-88AC-4C0BCB4578B4> /System/Library/Frameworks/Metal.framework/Versions/A/Metal
    0x7fff51072000 -     0x7fff5108dfff  com.apple.MetalPerformanceShaders.MPSCore (1.0 - 1) <AD754E8F-CA00-3878-9AF3-208C224A230B> /System/Library/Frameworks/MetalPerformanceShaders.framework/Frameworks/MPSCore.framework/Versions/A/MPSCore
    0x7fff5108e000 -     0x7fff510fdfef  com.apple.MetalPerformanceShaders.MPSImage (1.0 - 1) <338B7779-E608-3D68-8A07-2ACC11299744> /System/Library/Frameworks/MetalPerformanceShaders.framework/Frameworks/MPSImage.framework/Versions/A/MPSImage
    0x7fff510fe000 -     0x7fff51122fff  com.apple.MetalPerformanceShaders.MPSMatrix (1.0 - 1) <9CE072D7-853B-3939-9645-7EB951376B87> /System/Library/Frameworks/MetalPerformanceShaders.framework/Frameworks/MPSMatrix.framework/Versions/A/MPSMatrix
    0x7fff51123000 -     0x7fff5120aff7  com.apple.MetalPerformanceShaders.MPSNeuralNetwork (1.0 - 1) <0DE891AD-27E5-38FF-AEC8-4A95356C4357> /System/Library/Frameworks/MetalPerformanceShaders.framework/Frameworks/MPSNeuralNetwork.framework/Versions/A/MPSNeuralNetwork
    0x7fff5120b000 -     0x7fff5120bff7  com.apple.MetalPerformanceShaders.MetalPerformanceShaders (1.0 - 1) <2D2D261C-50B0-32F9-BF9A-5C01382BB528> /System/Library/Frameworks/MetalPerformanceShaders.framework/Versions/A/MetalPerformanceShaders
    0x7fff5220a000 -     0x7fff52216ffb  com.apple.NetFS (6.0 - 4.0) <471DD96F-FA2E-3FE9-9746-2519A6780D1A> /System/Library/Frameworks/NetFS.framework/Versions/A/NetFS
    0x7fff55008000 -     0x7fff55062ff7  com.apple.opencl (2.8.24 - 2.8.24) <1104D870-CE68-3240-81D7-C58D8A24EF0A> /System/Library/Frameworks/OpenCL.framework/Versions/A/OpenCL
    0x7fff55063000 -     0x7fff5507fffb  com.apple.CFOpenDirectory (10.13 - 207.50.1) <29F55F7B-379F-3053-8FF3-5C6675A3DD4D> /System/Library/Frameworks/OpenDirectory.framework/Versions/A/Frameworks/CFOpenDirectory.framework/Versions/A/CFOpenDirectory
    0x7fff55080000 -     0x7fff5508bfff  com.apple.OpenDirectory (10.13 - 207.50.1) <F895547D-4915-353F-9C1E-E95172BA803B> /System/Library/Frameworks/OpenDirectory.framework/Versions/A/OpenDirectory
    0x7fff5620a000 -     0x7fff5620cfff  libCVMSPluginSupport.dylib (16.7.4) <6846D939-478C-3AE3-9DCD-CD4F4CD05409> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCVMSPluginSupport.dylib
    0x7fff5620d000 -     0x7fff56212ffb  libCoreFSCache.dylib (162.9) <1BBC6180-FCC0-31EB-8C0A-A1287A9A87C3> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCoreFSCache.dylib
    0x7fff56213000 -     0x7fff56217fff  libCoreVMClient.dylib (162.9) <8F26B9F9-75DB-3292-9DE8-D9E023B2690C> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libCoreVMClient.dylib
    0x7fff56218000 -     0x7fff56221ff3  libGFXShared.dylib (16.7.4) <6187AD8B-1CD2-3775-84CD-76A0EA8BCDD4> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGFXShared.dylib
    0x7fff56222000 -     0x7fff5622dfff  libGL.dylib (16.7.4) <2BB333D3-5C61-33DF-8545-06DF2D08B83D> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib
    0x7fff5622e000 -     0x7fff56269fe7  libGLImage.dylib (16.7.4) <4DA003CE-0B74-3FE4-808C-B2FBCE517EB4> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGLImage.dylib
    0x7fff563d8000 -     0x7fff56416ffb  libGLU.dylib (16.7.4) <BCB09CD8-EB0E-38FA-8B5A-9E29532EE364> /System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGLU.dylib
    0x7fff56d8e000 -     0x7fff56d9dff3  com.apple.opengl (16.7.4 - 16.7.4) <7B71A596-B6D8-335A-B7CA-8684D83B9C0E> /System/Library/Frameworks/OpenGL.framework/Versions/A/OpenGL
    0x7fff57bec000 -     0x7fff57e38ff7  com.apple.QuartzCore (1.11 - 584.64.2) <DDA39332-DE09-3737-A332-0002AE05DD39> /System/Library/Frameworks/QuartzCore.framework/Versions/A/QuartzCore
    0x7fff5866d000 -     0x7fff58998fff  com.apple.security (7.0 - 58286.70.14) <FE163834-A993-3D19-8D7E-9546B4F999B6> /System/Library/Frameworks/Security.framework/Versions/A/Security
    0x7fff58999000 -     0x7fff58a25ff7  com.apple.securityfoundation (6.0 - 55185.50.5) <B5F933AE-BF0B-36CB-B2D4-3C07DD952BCE> /System/Library/Frameworks/SecurityFoundation.framework/Versions/A/SecurityFoundation
    0x7fff58a57000 -     0x7fff58a5bffb  com.apple.xpc.ServiceManagement (1.0 - 1) <E3146BBE-7F32-3605-AD2B-54C0E70759DC> /System/Library/Frameworks/ServiceManagement.framework/Versions/A/ServiceManagement
    0x7fff58e00000 -     0x7fff58e70ff3  com.apple.SystemConfiguration (1.17 - 1.17) <CD4A4C66-7886-3323-A3B9-0C8952500856> /System/Library/Frameworks/SystemConfiguration.framework/Versions/A/SystemConfiguration
    0x7fff5bd6d000 -     0x7fff5be00fff  com.apple.APFS (1.0 - 1) <7CC77BF1-881B-357A-9E05-A73C661F830E> /System/Library/PrivateFrameworks/APFS.framework/Versions/A/APFS
    0x7fff5cba9000 -     0x7fff5cbf1ff3  com.apple.AppleJPEG (1.0 - 1) <8DD410CB-76A1-3F22-9A9F-0491FA0CEB4A> /System/Library/PrivateFrameworks/AppleJPEG.framework/Versions/A/AppleJPEG
    0x7fff5cc2c000 -     0x7fff5cc54fff  com.apple.applesauce (1.0 - ???) <CCA8B094-1BCE-3AE3-A0A7-D544C818DE36> /System/Library/PrivateFrameworks/AppleSauce.framework/Versions/A/AppleSauce
    0x7fff5d477000 -     0x7fff5d47eff7  com.apple.coreservices.BackgroundTaskManagement (1.0 - 57.1) <51A41CA3-DB1D-3380-993E-99C54AEE518E> /System/Library/PrivateFrameworks/BackgroundTaskManagement.framework/Versions/A/BackgroundTaskManagement
    0x7fff5eec0000 -     0x7fff5eec9ff3  com.apple.CommonAuth (4.0 - 2.0) <FBBD852E-FFFE-396B-A343-2C5DB7A3D819> /System/Library/PrivateFrameworks/CommonAuth.framework/Versions/A/CommonAuth
    0x7fff5f9dd000 -     0x7fff5f9edff7  com.apple.CoreEmoji (1.0 - 69.3) <A4357F5C-0C38-3A61-B456-D7321EB2CEE5> /System/Library/PrivateFrameworks/CoreEmoji.framework/Versions/A/CoreEmoji
    0x7fff60b95000 -     0x7fff60b99ffb  com.apple.DSExternalDisplay (3.1 - 380) <901B7F6D-376A-3848-99D0-170C4D00F776> /System/Library/PrivateFrameworks/DSExternalDisplay.framework/Versions/A/DSExternalDisplay
    0x7fff61c64000 -     0x7fff62092fff  com.apple.vision.FaceCore (3.3.2 - 3.3.2) <B574FE33-4A41-3611-9738-388EBAF03E37> /System/Library/PrivateFrameworks/FaceCore.framework/Versions/A/FaceCore
    0x7fff625c2000 -     0x7fff625c4fff  libGPUCompiler.dylib (802.4.8) <F0E20243-21D0-3C69-AFAD-469E68605E37> /System/Library/PrivateFrameworks/GPUCompiler.framework/Versions/3802/Libraries/libGPUCompiler.dylib
    0x7fff625c5000 -     0x7fff62614ff7  libGPUCompilerImpl.dylib (802.4.8) <791D837A-ABF1-3D10-BA82-28C8A4FF05C5> /System/Library/PrivateFrameworks/GPUCompiler.framework/Versions/3802/Libraries/libGPUCompilerImpl.dylib
    0x7fff62615000 -     0x7fff62f6fffb  libGPUCompilerImplLazy.dylib (802.4.8) <DBC983B8-C301-33C7-8087-74AC307DC8C3> /System/Library/PrivateFrameworks/GPUCompiler.framework/Versions/3802/Libraries/libGPUCompilerImplLazy.dylib
    0x7fff62f70000 -     0x7fff63cedfff  libLLVM.dylib (802.4.8) <366FEF47-8B80-36C2-841F-A57D027A47B2> /System/Library/PrivateFrameworks/GPUCompiler.framework/Versions/3802/Libraries/libLLVM.dylib
    0x7fff6535a000 -     0x7fff6535ffff  com.apple.GPUWrangler (3.20.0 - 3.20.0) <F73FEE8E-9D02-3AC6-BE94-841175614A3D> /System/Library/PrivateFrameworks/GPUWrangler.framework/Versions/A/GPUWrangler
    0x7fff660d5000 -     0x7fff660e4fff  com.apple.GraphVisualizer (1.0 - 5) <B993B8A2-5700-3DFC-9EB7-4CCEE8F959F1> /System/Library/PrivateFrameworks/GraphVisualizer.framework/Versions/A/GraphVisualizer
    0x7fff66167000 -     0x7fff661dbfff  com.apple.Heimdal (4.0 - 2.0) <9F4D7008-944E-3A7C-8E58-A9F7D8497C32> /System/Library/PrivateFrameworks/Heimdal.framework/Versions/A/Heimdal
    0x7fff66aeb000 -     0x7fff66af2ff7  com.apple.IOAccelerator (378.28 - 378.28) <BE5CBEAA-314E-348B-BE85-7E4B2E4C42FF> /System/Library/PrivateFrameworks/IOAccelerator.framework/Versions/A/IOAccelerator
    0x7fff66af6000 -     0x7fff66b0dfff  com.apple.IOPresentment (1.0 - 35.1) <53B47F2A-9A9A-33F5-ADCB-FF766292B93A> /System/Library/PrivateFrameworks/IOPresentment.framework/Versions/A/IOPresentment
    0x7fff67197000 -     0x7fff6728cff7  com.apple.LanguageModeling (1.0 - 159.5.3) <7F0AC200-E3DD-39FB-8A95-00DD70B66A9F> /System/Library/PrivateFrameworks/LanguageModeling.framework/Versions/A/LanguageModeling
    0x7fff6728d000 -     0x7fff672cffff  com.apple.Lexicon-framework (1.0 - 33.5) <DC94CF9E-1EB4-3C0E-B298-CA1190885276> /System/Library/PrivateFrameworks/Lexicon.framework/Versions/A/Lexicon
    0x7fff672d3000 -     0x7fff672daff7  com.apple.LinguisticData (1.0 - 238.3) <49A54649-1021-3DBD-99B8-1B2EDFFA5378> /System/Library/PrivateFrameworks/LinguisticData.framework/Versions/A/LinguisticData
    0x7fff675f8000 -     0x7fff675f9fff  libMTLCompilerHelper.dylib (125.30) <AD6EF70A-90E9-3B3E-997F-C390CA66728E> /System/Library/PrivateFrameworks/MTLCompiler.framework/Versions/3802/Libraries/libMTLCompilerHelper.dylib
    0x7fff675fa000 -     0x7fff67630ff7  com.apple.MTLCompiler (125.30 - 125.30) <BA03E903-1D78-3E75-B778-83AAB832D615> /System/Library/PrivateFrameworks/MTLCompiler.framework/Versions/3802/MTLCompiler
    0x7fff67fec000 -     0x7fff68055ff7  com.apple.gpusw.MetalTools (1.0 - 1) <2C0FE0FB-FAC2-3906-A46D-CF68392EC549> /System/Library/PrivateFrameworks/MetalTools.framework/Versions/A/MetalTools
    0x7fff68276000 -     0x7fff682a0ffb  com.apple.MultitouchSupport.framework (1614.1 - 1614.1) <A0709B43-FA9E-3617-8E7A-D68CDFAB2167> /System/Library/PrivateFrameworks/MultitouchSupport.framework/Versions/A/MultitouchSupport
    0x7fff68507000 -     0x7fff68512fff  com.apple.NetAuth (6.2 - 6.2) <2CFA1228-61A1-3708-988D-30499A1D6A9F> /System/Library/PrivateFrameworks/NetAuth.framework/Versions/A/NetAuth
    0x7fff6e553000 -     0x7fff6e7effff  com.apple.SkyLight (1.600.0 - 312.103.11) <3E03D943-2BA4-3658-B014-1675DD191696> /System/Library/PrivateFrameworks/SkyLight.framework/Versions/A/SkyLight
    0x7fff70164000 -     0x7fff7016cff7  com.apple.TCC (1.0 - 1) <E1EB7272-FE6F-39AB-83CA-B2B5F2A88D9B> /System/Library/PrivateFrameworks/TCC.framework/Versions/A/TCC
    0x7fff71e13000 -     0x7fff71e15ffb  com.apple.loginsupport (1.0 - 1) <D1232C1B-80EA-3DF8-9466-013695D0846E> /System/Library/PrivateFrameworks/login.framework/Versions/A/Frameworks/loginsupport.framework/Versions/A/loginsupport
    0x7fff71f7c000 -     0x7fff71fafff7  libclosured.dylib (551.5) <112BC241-6626-3848-8DD8-B34B5B6F7ABC> /usr/lib/closure/libclosured.dylib
    0x7fff72069000 -     0x7fff720a2ff7  libCRFSuite.dylib (41) <FE5EDB68-2593-3C2E-BBAF-1C52D206F296> /usr/lib/libCRFSuite.dylib
    0x7fff720a3000 -     0x7fff720aefff  libChineseTokenizer.dylib (28) <53633C9B-A3A8-36F7-A53C-432D802F4BB8> /usr/lib/libChineseTokenizer.dylib
    0x7fff72140000 -     0x7fff72141ff3  libDiagnosticMessagesClient.dylib (104) <9712E980-76EE-3A89-AEA6-DF4BAF5C0574> /usr/lib/libDiagnosticMessagesClient.dylib
    0x7fff72178000 -     0x7fff72342ff3  libFosl_dynamic.dylib (17.8) <413FDC7A-28B1-3966-9E25-9536E0164B4F> /usr/lib/libFosl_dynamic.dylib
    0x7fff72362000 -     0x7fff72369fff  libMatch.1.dylib (31) <74AB4815-11D1-3930-A559-BD6550CE5865> /usr/lib/libMatch.1.dylib
    0x7fff7237a000 -     0x7fff7237afff  libOpenScriptingUtil.dylib (174) <610F0242-7CE5-3C86-951B-B646562694AF> /usr/lib/libOpenScriptingUtil.dylib
    0x7fff724b6000 -     0x7fff724b7ffb  libSystem.B.dylib (1252.50.4) <237634FA-3FEA-3C76-8236-DE684D9894A2> /usr/lib/libSystem.B.dylib
    0x7fff7254a000 -     0x7fff7254afff  libapple_crypto.dylib (109.50.14) <48BA2E76-BF2F-3522-A54E-D7FB7EAF7A57> /usr/lib/libapple_crypto.dylib
    0x7fff7254b000 -     0x7fff72561ff7  libapple_nghttp2.dylib (1.24) <01402BC4-4822-3676-9C80-50D83F816424> /usr/lib/libapple_nghttp2.dylib
    0x7fff72562000 -     0x7fff7258cff3  libarchive.2.dylib (54) <8FC28DD8-E315-3C3E-95FE-D1D2CBE49888> /usr/lib/libarchive.2.dylib
    0x7fff72694000 -     0x7fff72694ff3  libauto.dylib (187) <A05C7900-F8C7-3E75-8D3F-909B40C19717> /usr/lib/libauto.dylib
    0x7fff72695000 -     0x7fff7274dff3  libboringssl.dylib (109.50.14) <E6813F87-B5E4-3F7F-A725-E6A7F2BD02EC> /usr/lib/libboringssl.dylib
    0x7fff7274e000 -     0x7fff7275eff3  libbsm.0.dylib (39) <6BC96A72-AFBE-34FD-91B1-748A530D8AE6> /usr/lib/libbsm.0.dylib
    0x7fff7275f000 -     0x7fff7276cffb  libbz2.1.0.dylib (38) <0A5086BB-4724-3C14-979D-5AD4F26B5B45> /usr/lib/libbz2.1.0.dylib
    0x7fff7276d000 -     0x7fff727c3fff  libc++.1.dylib (400.9) <7D3DACCC-3804-393C-ABC1-1A580FD00CB6> /usr/lib/libc++.1.dylib
    0x7fff727c4000 -     0x7fff727e8ff7  libc++abi.dylib (400.8.2) <EF5E37D7-11D9-3530-BE45-B986612D13E2> /usr/lib/libc++abi.dylib
    0x7fff727ea000 -     0x7fff727fafff  libcmph.dylib (6) <890DEC4C-4334-393C-8B56-7C8560BBED9D> /usr/lib/libcmph.dylib
    0x7fff727fb000 -     0x7fff72812fd3  libcompression.dylib (47.60.2) <CC7ACB0A-49CD-3564-978F-49F843186F27> /usr/lib/libcompression.dylib
    0x7fff72abd000 -     0x7fff72ad5ff7  libcoretls.dylib (155.50.1) <D350052E-DC4D-3185-ADBA-BA48EDCEE955> /usr/lib/libcoretls.dylib
    0x7fff72ad6000 -     0x7fff72ad7ff3  libcoretls_cfhelpers.dylib (155.50.1) <B297F5D8-F2FE-3566-A752-E9D998B9C039> /usr/lib/libcoretls_cfhelpers.dylib
    0x7fff72fa8000 -     0x7fff72ffeff3  libcups.2.dylib (462.2.5) <EA944DD1-0B60-32E9-8FB4-BE642D2E7352> /usr/lib/libcups.2.dylib
    0x7fff7313e000 -     0x7fff7313efff  libenergytrace.dylib (16) <A92AB8B8-B986-3CE6-980D-D55090FEF387> /usr/lib/libenergytrace.dylib
    0x7fff73175000 -     0x7fff7317aff3  libheimdal-asn1.dylib (520.50.8) <6C10CD33-2920-340F-A98B-E1A465A40D03> /usr/lib/libheimdal-asn1.dylib
    0x7fff731a6000 -     0x7fff73297ff7  libiconv.2.dylib (51.50.1) <2FEC9707-3FAF-3828-A50D-8605086D060F> /usr/lib/libiconv.2.dylib
    0x7fff73298000 -     0x7fff734bfffb  libicucore.A.dylib (59181.0.1) <2CE6205F-D375-3BF5-AA0A-3254BC4773D0> /usr/lib/libicucore.A.dylib
    0x7fff7350c000 -     0x7fff7350dfff  liblangid.dylib (128) <39C39393-0D05-301D-93B2-F224FC4949AA> /usr/lib/liblangid.dylib
    0x7fff7350e000 -     0x7fff73527ffb  liblzma.5.dylib (10) <3D419A50-961F-37D2-8A01-3DC7AB7B8D18> /usr/lib/liblzma.5.dylib
    0x7fff73528000 -     0x7fff7353eff7  libmarisa.dylib (9) <D6D2D55D-1D2E-3442-B152-B18803C0ABB4> /usr/lib/libmarisa.dylib
    0x7fff735ef000 -     0x7fff73817ff7  libmecabra.dylib (779.7.6) <F462F170-E872-3D09-B219-973D5E99C09F> /usr/lib/libmecabra.dylib
    0x7fff7381c000 -     0x7fff7384cffb  libncurses.5.4.dylib (53) <030DF747-F71B-367A-83EE-2F30B7947929> /usr/lib/libncurses.5.4.dylib
    0x7fff739ef000 -     0x7fff73b6afff  libnetwork.dylib (1229.70.2) <E185D902-AC7F-3044-87C0-AE2887C59CE7> /usr/lib/libnetwork.dylib
    0x7fff73bf1000 -     0x7fff73fe23b7  libobjc.A.dylib (723) <BEEA51E2-1C4D-3672-87F6-F267B4AC6221> /usr/lib/libobjc.A.dylib
    0x7fff73ff5000 -     0x7fff73ff9fff  libpam.2.dylib (22) <7B4D2CE2-1438-387A-9802-5CEEFBF26F86> /usr/lib/libpam.2.dylib
    0x7fff73ffc000 -     0x7fff74030fff  libpcap.A.dylib (79.20.1) <FA13918B-A247-3181-B256-9B852C7BA316> /usr/lib/libpcap.A.dylib
    0x7fff740af000 -     0x7fff740cbffb  libresolv.9.dylib (65) <E8F3415B-4472-3202-8901-41FD87981DB2> /usr/lib/libresolv.9.dylib
    0x7fff740cd000 -     0x7fff74106ff3  libsandbox.1.dylib (765.70.1) <D6521DD5-48E0-3465-863D-6B3E24A645B8> /usr/lib/libsandbox.1.dylib
    0x7fff7411c000 -     0x7fff742a9ff7  libsqlite3.dylib (274.8.1) <B70A2908-E0F7-364E-952A-1D2D19787B89> /usr/lib/libsqlite3.dylib
    0x7fff7447d000 -     0x7fff744ddff3  libusrtcp.dylib (1229.70.2) <1E065228-D0E3-3808-9405-894056C6BEC0> /usr/lib/libusrtcp.dylib
    0x7fff744de000 -     0x7fff744e1ffb  libutil.dylib (51.20.1) <216D18E5-0BAF-3EAF-A38E-F6AC37CBABD9> /usr/lib/libutil.dylib
    0x7fff744e2000 -     0x7fff744efff3  libxar.1.dylib (417.1) <351781D5-3CCF-320F-BB5A-4DFCC1CCD31D> /usr/lib/libxar.1.dylib
    0x7fff744f3000 -     0x7fff745dafff  libxml2.2.dylib (31.13) <8C12B82A-66FD-330C-9BEA-AAC090C7076A> /usr/lib/libxml2.2.dylib
    0x7fff745db000 -     0x7fff74603fff  libxslt.1.dylib (15.12) <4A5E011D-8B29-3135-A52B-9A9070ABD752> /usr/lib/libxslt.1.dylib
    0x7fff74604000 -     0x7fff74616ffb  libz.1.dylib (70) <48C67CFC-940D-3857-8DAD-857774605352> /usr/lib/libz.1.dylib
    0x7fff746b2000 -     0x7fff746b6ff7  libcache.dylib (80) <092479CB-1008-3A83-BECF-E115F24D13C1> /usr/lib/system/libcache.dylib
    0x7fff746b7000 -     0x7fff746c1ff3  libcommonCrypto.dylib (60118.50.1) <029F5985-9B6E-3DCB-9B96-FD007678C6A7> /usr/lib/system/libcommonCrypto.dylib
    0x7fff746c2000 -     0x7fff746c9fff  libcompiler_rt.dylib (62) <968B8E3F-3681-3230-9D78-BB8732024F6E> /usr/lib/system/libcompiler_rt.dylib
    0x7fff746ca000 -     0x7fff746d3ffb  libcopyfile.dylib (146.50.5) <3885083D-50D8-3EEC-B481-B2E605180D7F> /usr/lib/system/libcopyfile.dylib
    0x7fff746d4000 -     0x7fff74759ffb  libcorecrypto.dylib (562.70.3) <37AF8EC6-BF34-3D15-BC3A-A9B98F2427D4> /usr/lib/system/libcorecrypto.dylib
    0x7fff747e1000 -     0x7fff7481aff7  libdispatch.dylib (913.60.3) <BF368549-2DFB-3530-B4CB-31D5EDAC4F2F> /usr/lib/system/libdispatch.dylib
    0x7fff7481b000 -     0x7fff74838ff7  libdyld.dylib (551.5) <49BF9E96-8297-30CF-8AA6-128CC14054B2> /usr/lib/system/libdyld.dylib
    0x7fff74839000 -     0x7fff74839ffb  libkeymgr.dylib (28) <E34E283E-90FA-3C59-B48E-1277CDB9CDCE> /usr/lib/system/libkeymgr.dylib
    0x7fff7483a000 -     0x7fff74846ff3  libkxld.dylib (4570.71.45) <03FEE7FE-74F1-3EAE-99AE-DEB3EC414AEF> /usr/lib/system/libkxld.dylib
    0x7fff74847000 -     0x7fff74847ff7  liblaunch.dylib (1205.70.12) <4950A0B3-5EE1-3F9A-8B1A-94FB85FCCA2C> /usr/lib/system/liblaunch.dylib
    0x7fff74848000 -     0x7fff7484cffb  libmacho.dylib (906) <1902A611-081A-3452-B11E-EBD1B166E831> /usr/lib/system/libmacho.dylib
    0x7fff7484d000 -     0x7fff7484fff3  libquarantine.dylib (86) <26C0BA22-8F93-3A07-9A4E-C8D53D2CE42E> /usr/lib/system/libquarantine.dylib
    0x7fff74850000 -     0x7fff74851ff3  libremovefile.dylib (45) <711E18B2-5BBE-3211-A916-56740C27D17A> /usr/lib/system/libremovefile.dylib
    0x7fff74852000 -     0x7fff74869fff  libsystem_asl.dylib (356.70.1) <39E46A6F-B228-3E78-B83E-1779F9707A39> /usr/lib/system/libsystem_asl.dylib
    0x7fff7486a000 -     0x7fff7486afff  libsystem_blocks.dylib (67) <17303FDF-0D2D-3963-B05E-B4DF63052D47> /usr/lib/system/libsystem_blocks.dylib
    0x7fff7486b000 -     0x7fff748f4ff7  libsystem_c.dylib (1244.50.9) <1187BFE8-4576-3247-8177-481554E1F9E7> /usr/lib/system/libsystem_c.dylib
    0x7fff748f5000 -     0x7fff748f8ffb  libsystem_configuration.dylib (963.50.9) <A5DC1AFC-2C3E-3113-BE20-48F96064DB0F> /usr/lib/system/libsystem_configuration.dylib
    0x7fff748f9000 -     0x7fff748fcffb  libsystem_coreservices.dylib (51) <486000D3-D8CB-3BE7-8EE5-8BF380DE6DF7> /usr/lib/system/libsystem_coreservices.dylib
    0x7fff748fd000 -     0x7fff748fefff  libsystem_darwin.dylib (1244.50.9) <09C21A4A-9EE0-388B-A9D9-DFF8F6758791> /usr/lib/system/libsystem_darwin.dylib
    0x7fff748ff000 -     0x7fff74905ff7  libsystem_dnssd.dylib (878.70.3) <E117689D-8CF3-3010-9EED-B71C033BF8D7> /usr/lib/system/libsystem_dnssd.dylib
    0x7fff74906000 -     0x7fff7494fff7  libsystem_info.dylib (517.30.1) <AB634A98-B8AA-3804-8436-38261FC8EC4D> /usr/lib/system/libsystem_info.dylib
    0x7fff74950000 -     0x7fff74976ff7  libsystem_kernel.dylib (4570.71.45) <939FEA3D-15A3-33E5-9476-789AF120C330> /usr/lib/system/libsystem_kernel.dylib
    0x7fff74977000 -     0x7fff749c2fcb  libsystem_m.dylib (3147.50.1) <17570F46-566C-39FC-BEF6-635A355DD549> /usr/lib/system/libsystem_m.dylib
    0x7fff749c3000 -     0x7fff749e2ff7  libsystem_malloc.dylib (140.50.7) <A45A484C-3BDE-3BC4-A219-726E3CB332D9> /usr/lib/system/libsystem_malloc.dylib
    0x7fff749e3000 -     0x7fff74b13ff7  libsystem_network.dylib (1229.70.2) <5E86B2DE-9E15-3354-8714-4094ED5F698D> /usr/lib/system/libsystem_network.dylib
    0x7fff74b14000 -     0x7fff74b1effb  libsystem_networkextension.dylib (767.70.2) <9DC03712-552D-3AEE-9519-B5ED70980B70> /usr/lib/system/libsystem_networkextension.dylib
    0x7fff74b1f000 -     0x7fff74b28ff3  libsystem_notify.dylib (172) <08012EC0-2CD2-34BE-BF93-E7F56491299A> /usr/lib/system/libsystem_notify.dylib
    0x7fff74b29000 -     0x7fff74b30ff7  libsystem_platform.dylib (161.50.1) <6355EE2D-5456-3CA8-A227-B96E8F1E2AF8> /usr/lib/system/libsystem_platform.dylib
    0x7fff74b31000 -     0x7fff74b3cfff  libsystem_pthread.dylib (301.50.1) <0E51CCBA-91F2-34E1-BF2A-FEEFD3D321E4> /usr/lib/system/libsystem_pthread.dylib
    0x7fff74b3d000 -     0x7fff74b40fff  libsystem_sandbox.dylib (765.70.1) <553DFCC6-9D31-3B9C-AB7C-30F6F265786D> /usr/lib/system/libsystem_sandbox.dylib
    0x7fff74b41000 -     0x7fff74b42ff3  libsystem_secinit.dylib (30) <DE8D14E8-A276-3FF8-AE13-77F7040F33C1> /usr/lib/system/libsystem_secinit.dylib
    0x7fff74b43000 -     0x7fff74b4aff7  libsystem_symptoms.dylib (820.60.3) <70753784-099A-3E44-9E80-7364C9901CDA> /usr/lib/system/libsystem_symptoms.dylib
    0x7fff74b4b000 -     0x7fff74b5efff  libsystem_trace.dylib (829.70.1) <3A6CB706-8CA6-3616-8AFC-14AAD7FAF187> /usr/lib/system/libsystem_trace.dylib
    0x7fff74b60000 -     0x7fff74b65ff7  libunwind.dylib (35.3) <BEF3FB49-5604-3B5F-82B5-332B80023AC3> /usr/lib/system/libunwind.dylib
    0x7fff74b66000 -     0x7fff74b93ff7  libxpc.dylib (1205.70.12) <7B82608D-ED82-35C1-B13F-99855E25D6DC> /usr/lib/system/libxpc.dylib

External Modification Summary:
  Calls made by other processes targeting this process:
    task_for_pid: 0
    thread_create: 0
    thread_set_state: 0
  Calls made by this process:
    task_for_pid: 0
    thread_create: 0
    thread_set_state: 0
  Calls made by all processes on this machine:
    task_for_pid: 3354307
    thread_create: 0
    thread_set_state: 1488

VM Region Summary:
ReadOnly portion of Libraries: Total=329.9M resident=0K(0%) swapped_out_or_unallocated=329.9M(100%)
Writable regions: Total=72.4M written=0K(0%) resident=0K(0%) swapped_out=0K(0%) unallocated=72.4M(100%)
 
                                VIRTUAL   REGION 
REGION TYPE                        SIZE    COUNT (non-coalesced) 
===========                     =======  ======= 
Activity Tracing                   256K        2 
Kernel Alloc Once                    8K        2 
MALLOC                            61.3M       16 
MALLOC guard page                   16K        5 
STACK GUARD                       56.0M        7 
Stack                             10.5M        7 
__DATA                            16.8M      193 
__FONT_DATA                          4K        2 
__LINKEDIT                       195.6M        6 
__TEXT                           134.4M      192 
__UNICODE                          560K        2 
mapped file                       6412K        2 
shared memory                       44K        5 
===========                     =======  ======= 
TOTAL                            481.7M      428
Comment 12 Saam Barati 2019-06-27 10:48:21 PDT
(In reply to Truitt Savell from comment #10)
> It looks like the changes in https://trac.webkit.org/changeset/246875/webkit
> Broke two tests:
> webgpu/whlsl-huge-array.html
> webgpu/whlsl-make-array-reference.html
> 
> History:
> http://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> html#showAllRuns=true&tests=webgpu%2Fwhlsl-huge-array.html%20webgpu%2Fwhlsl-
> make-array-reference.html
> 
> Diff:
> ---
> /Volumes/Data/slave/highsierra-debug-tests-wk2/build/layout-test-results/
> webgpu/whlsl-huge-array-expected.txt
> +++
> /Volumes/Data/slave/highsierra-debug-tests-wk2/build/layout-test-results/
> webgpu/whlsl-huge-array-actual.txt
> @@ -1,4 +1,4 @@
> -PASS 
> +FAIL 
>  PASS successfullyParsed is true
>  
>  TEST COMPLETE

We're disabling WEBGPU for now on High Sierra:
https://trac.webkit.org/changeset/246888/webkit